Procedure GetBits(cBuffer:String;nBitStart,nBitCount:Integer):Integer
  Var n,nRet : Integer
  nRet:=0
  n:=0
  While n<nBitCount
    nRet:=nRet*2
    If TestBit(Asc(cBuffer[((nBitStart+n) Div 8)+1,1]),7-((nBitStart+n) Mod 8))
      nRet:=nRet+1
    End
    n++
  End
  Return nRet
EndProc

Procedure CharToString(Var nBuffer:Char[]):String
  Var n : Integer
  Var c: String
  n:=0
  While n<=High(1,nBuffer)
    c:=c+nBuffer[n]
    n++
  End
  Return c
EndProc

Procedure GetPicSize(cFile:STRING;VAR nWidth,nHeight:Integer):Integer
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. Ermittelt die Gre eines Bildes (gif, jpg und png)
  ..
  .. cFile  = Dateiname
  .. nWidth = Rckgabe Breite in Pixeln
  .. nHeight= Rckgabe Hhe in Pixeln
  .. Rckgabe: 1=OK / 0=Fehler (Datei nicht vorhanden oder unbekanntes Format)
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. Get the size (width x height) of gif, jpg and png
  ..
  .. cFile  = filename
  .. nWidth = returns width in pixel
  .. nHeight= returns height in pixel
  .. Return:  1=OK / 0=Error (File not found or unrecognized format)
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. History:
  .. 17.05.2001 Horst Klier: initial release
  .. 08.02.2002 Sergey Tsybov: Bugfix - manche JPG-Dateien fhrten zur Endlosschleife
  .. 17.03.2003 Horst Klier: support for swf
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. Copyright 2001-2003 / tdb Software Service GmbH
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Var c : STRING
  Var nRet : REAL
  Var n : Integer
  Var nBitPerNum : Integer
  Var nPos : Integer
  Var nSkip : Integer
  Var fh : Integer
  Var nBuffer : char[100]
  Var cBuffer : String
  nWidth:=0
  nHeight:=0
  If IsFile(cFile)
    If Lower(RightStr(cFile,4))='.gif'
      ..
      .. GIF
      ..
      CopyFile(cFile,'ramtext:pic')
      If RAMText_Part('ramtext:pic',1,3)='GIF'
        nWidth:=ASC(ramtext_part('ramtext:pic',7,1))+(256*ASC(ramtext_part('ramtext:pic',8,1)))
        nHeight:=ASC(ramtext_part('ramtext:pic',9,1))+(256*ASC(ramtext_part('ramtext:pic',10,1)))
        nRet:=1
      End
    ElsIf Lower(RightStr(cFile,4))='.jpg' or Lower(RightStr(cFile,5))='.jpeg'
      ..
      .. JPG
      ..
      CopyFile(cFile,'ramtext:pic')
      nPos := 3
      While nPos<GetSize('ramtext:pic') and (nHeight=0 or nWidth=0)
        If Asc(ramtext_part('ramtext:pic',nPos,1))#255
          nPos++
        Else
          If Asc(ramtext_part('ramtext:pic',nPos+1,1))#12*16
            If Asc(ramtext_part('ramtext:pic',nPos+1,1)) in [01,208,209,210,211,212,213,214,215] .. Marker ohne Lngenangabe
              nPos++
              nPos++
            Else
              nPos:=nPos+(ASC(ramtext_part('ramtext:pic',nPos+2,1))*256+ASC(ramtext_part('ramtext:pic',nPos+3,1)))+2
            End
          Else
            nHeight:=ASC(ramtext_part('ramtext:pic',nPos+6,1))+(256*ASC(ramtext_part('ramtext:pic',nPos+5,1)))
            nWidth:=ASC(ramtext_part('ramtext:pic',nPos+8,1))+(256*ASC(ramtext_part('ramtext:pic',nPos+7,1)))
            nRet:=1
          End
        End
      End
    ElsIf Lower(RightStr(cFile,4))='.png'
      ..
      .. PNG
      ..
      CopyFile(cFile,'ramtext:pic')
      c:=ramtext_part('ramtext:pic',1,8)
      If Asc(c[1,1])=137 and ASC(c[2,1])=80 and ASC(c[3,1])=78 and ASC(c[4,1])=71 and ASC(c[5,1])=13 and ASC(c[6,1])=10 and ASC(c[7,1])=26 and ASC(c[8,1])=10
        If RAMText_Part('ramtext:pic',13,4)='IHDR' .. IHDR Chunk muss am Anfang sein
          nWidth:=ASC(ramtext_part('ramtext:pic',nPos+17,1))*256*256*256
          nWidth:=nWidth+ASC(ramtext_part('ramtext:pic',nPos+18,1))*256*256
          nWidth:=nWidth+ASC(ramtext_part('ramtext:pic',nPos+19,1))*256
          nWidth:=nWidth+ASC(ramtext_part('ramtext:pic',nPos+20,1))
          nHeight:=ASC(ramtext_part('ramtext:pic',nPos+21,1))*256*256*256
          nHeight:=nHeight+ASC(ramtext_part('ramtext:pic',nPos+22,1))*256*256
          nHeight:=nHeight+ASC(ramtext_part('ramtext:pic',nPos+23,1))*256
          nHeight:=nHeight+ASC(ramtext_part('ramtext:pic',nPos+24,1))
          nRet:=1
        End
      End
    ElsIf Lower(RightStr(cFile,4))='.swf'
      ..
      .. SWF / Flash
      ..
      fh:=F_Open(cFile)
      F_Seek(fh,8)
      F_Read(fh,nBuffer)
      c:=CharToString(nBuffer)
      n:=GetBits(c,0,5)
      nBitPerNum:=n
      nPos:=5
      //n:=GetBits(c,nPos,nBitPerNum) // MinX immer 0
      nPos:=nPos+nBitPerNum
      n:=GetBits(c,nPos,nBitPerNum)   // MaxX ist Breite in Twips (Pixel mal 20)
      nWidth:=n Div 20
      nPos:=nPos+nBitPerNum
      //n:=GetBits(c,nPos,nBitPerNum) // MinY immer 0
      nPos:=nPos+nBitPerNum
      n:=GetBits(c,nPos,nBitPerNum)   // MaxY ist Hhe in Twips (Pixel mal 20)
      nHeight:=n Div 20
      nRet:=1
    End
  End
  Return nRet
endproc

procedure GetThumbSize(cFile:STRING;VAR nWidth,nHeight:Integer;nMaxWidth,nMaxHeight,nMode:Integer):Integer
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. Ermittelt die Thumbnailgre eines Bildes
  .. Dabei kann eine maximalgre fr Breite und Hhe angegeben werden
  .. und ob kleinere Bilder vergrert werden
  ..
  .. Benutzt die Prozedur GetPicSize
  ..
  .. cFile      = Dateiname
  .. nWidth     = Rckgabe Breite in Pixeln
  .. nHeight    = Rckgabe Hhe in Pixeln
  .. nMaxWidth  = Maximalbreite
  .. nMaxHeight = Maximalhhe
  .. nMode      = 0=Kleinere Bilder werden vergrert
  ..              1=Kleinere Bilder behalten ursprngliche Gre
  .. Rckgabe: 1=OK / 0=Fehler (Datei nicht vorhanden oder unbekanntes Format)
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. Get the thumbnail size (width x height) of gif, jpg and png
  .. The max of width and height can be submited,
  .. also how to handle (stretch) smaller pictures
  ..
  .. procedure GetPicSize will be used
  ..
  .. cFile      = filename
  .. nWidth     = returns width in pixel
  .. nHeight    = returns height in pixel
  .. nMaxWidth  = max. Width
  .. nMaxHeight = max. height
  .. nMode      = 0=smaller pictures are stretched
  ..              1=smaller pictures not stretched
  .. Return:  1=OK / 0=Error (File not found or unrecognized format)
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. History:
  .. 17.05.2001 Horst Klier: initial release
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ..
  .. Copyright 2001 / tdb Software Service GmbH
  ..
  ..~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Var nRet,xRatio,yRatio : REAL
  If nMaxWidth=0 then nMaxWidth:=1 End
  If nMaxHeight=0 then nMaxHeight:=1 End
  nRet:=GetPicSize(cFile,nWidth,nHeight)
  If nRet
    xRatio:=nWidth/nMaxWidth
    yRatio:=nHeight/nMaxHeight
    .. Falls Verkleinert wird, oder Vergrern erlaubt ist
    If xRatio>1 or yRatio>1 or nMode=0
      If xRatio>yRatio
        nWidth:=nWidth/xRatio
        nHeight:=nHeight/xRatio
      Else
        nWidth:=nWidth/yRatio
        nHeight:=nHeight/yRatio
      End
    End
  End
  Return nRet
EndProc

